/*
 * (ߥå)ν򤹤롣
 * ƼγؽƤӽФ
 *
 * anthy_proc_commit() ƤФ
 */
#include <stdlib.h>

/* Patched by G-HAL, Thu,23 Oct,2008 */
#if !defined(__STDC_LIMIT_MACROS)
# define	__STDC_LIMIT_MACROS
#endif
#include <stdint.h>

#include <time.h>

#include "anthy/settings.h"		/* Patched by G-HAL, Fri,17 Oct,2008 */
#include <anthy/ordering.h>
#include <anthy/record.h>
#include <anthy/splitter.h>
#include <anthy/segment.h>
#include "sorter.h"
#include "src-worddic/exception_word_list.h"	/* Patched by G-HAL, Thu,21 Aug,2008 */
#include "src-worddic/dic_learn.h"	/* Patched by G-HAL, Fri,31 Oct,2008 */
#include "src-splitter/wordborder.h"	/* Patched by G-HAL, Sat,24 Jan,2009 */

/* #define MAX_OCHAIRE_ENTRY_COUNT 103424*/	/* Patched by G-HAL, Thu,13 Sep,2007. original: 100, ؽ OCHAIRE γؽξ */
/* #define MAX_OCHAIRE_LEN 32*/		/* Comment by G-HAL, Thu,13 Sep,2007. ؽ OCHAIRE κʸκĹ */
/* #define MAX_PREDICTION_ENTRY 49152*/	/* Patched by G-HAL, Thu,13 Sep,2007. original: 100, PREDICTION γؽξ */

/* #define MAX_UNKNOWN_WORD 2048*/	/* Patched by G-HAL, Thu,13 Sep,2007. original: 100, ̤θ UNKNOWN_WORD γؽξ */

/* 򴹤줿õ */
static void
learn_swapped_candidates(struct segment_list *sl)
{
 #if 0	/* Patched by G-HAL, Tue,02 Dec,2008, Tue,13 Jan,2009 */
  int i;
  struct seg_ent *seg;
  for (i = 0; i < sl->nr_segments; i++) {
    seg = anthy_get_nth_segment(sl, i);
    if (seg->committed != 0) {
      /* ǽθ(0)Ǥʤ(seg->committed)ߥåȤ줿 */
      anthy_swap_cand_ent(seg->cands[0],
			  seg->cands[seg->committed]);
    }
  }
  anthy_cand_swap_ageup();
 #else
  if (anthy_settings.anthy_mode.learn.enable_indeppair) {
    int i;
    for (i = 0; i < sl->nr_segments; ++i) {
      struct seg_ent* const seg = anthy_get_nth_segment(sl, i);
      if (0 <= seg->committed) {
	anthy_swap_cand_ent( seg->cands[0], seg->cands[seg->committed] );
      }
    }
    anthy_cand_swap_ageup();
  }
 #endif
}

/* ĹѤäʸѹФ */
static void
learn_resized_segment(struct splitter_context *sc,
		      struct segment_list *sl)
{
  int i;
  struct meta_word **mw
    = (struct meta_word **) alloca(sizeof(struct meta_word*) * sl->nr_segments);
  int *len_array
    = (int *) alloca(sizeof(int) * sl->nr_segments);
  unsigned int* const extra_flag = (unsigned int* const) alloca(sizeof(unsigned int) * sl->nr_segments);	/* Patched by G-HAL, Thu,27 Nov,2008 */

  /* ʸĹmeta_wordѰդ */
  for (i = 0; i < sl->nr_segments; i++) {
    struct seg_ent *se = anthy_get_nth_segment(sl, i);
    mw[i] = se->cands[se->committed]->mw;
    len_array[i] = se->str.len;
    extra_flag[i] = se->cands[se->committed]->flag;	/* Patched by G-HAL, Thu,27 Nov,2008 */
  }

  anthy_commit_border( sc, sl->nr_segments, mw, len_array, extra_flag );	/* Patched by G-HAL, Thu,27 Nov,2008 */
}

/* ĹѤäʸѹФ */
static void
clear_resized_segment(struct splitter_context *sc,
		      struct segment_list *sl)
{
  int *mark, i, from;
  struct seg_ent *seg;
  mark = (int*) alloca(sizeof(int)*sc->char_count);
  for (i = 0; i < sc->char_count; i++) {
    mark[i] = 0;
  }
  /* ºݤ˳ꤵ줿ʸĹޡ */
  from = 0;
  for (i = 0; i < sl->nr_segments; i++) {
    seg = anthy_get_nth_segment(sl, i);
    mark[from] = seg->len;
    from = from + seg->len;
  }
  for (i = 0; i < sc->char_count; i++) {
    int len = sc->ce[i].initial_seg_len;
    /* ǽĹȳꤵ줿ĹۤʤС
       Ȥʤä̤θβǽ */
    if (len && len != mark[i]) {
      xstr xs;
      xs.str = sc->ce[i].c;
      xs.len = len;
      anthy_forget_unused_unknown_word(&xs);
    }
  }
 #if 0	/* Patched by G-HAL, Sat,23 Aug,2008 */
  if (!anthy_select_section("UNKNOWN_WORD", 0)) {
    anthy_truncate_section(MAX_UNKNOWN_WORD);
  }
 #endif
}

#if 0	/* Patched by G-HAL, Tue,30 Dec,2008 */
/* recordˤؽη̤񤭹 */
static void
commit_ochaire(struct seg_ent *seg, int count, xstr* xs)
{
  int i;
  if (xs->len >= MAX_OCHAIRE_LEN) {
    return ;
  }
  if (anthy_select_row(xs, 1)) {
    return ;
  }
  anthy_set_nth_value(0, count);
  for (i = 0; i < count; i++, seg = seg->next) {
    anthy_set_nth_value(i * 2 + 1, seg->len);
    anthy_set_nth_xstr(i * 2 + 2, &seg->cands[seg->committed]->str);
  }
}

/* recordΰ󤹤뤿ˡؽΥͥƥ֤
   ȥä */
static void
release_negative_ochaire(struct splitter_context *sc,
			 struct segment_list *sl)
{
  int start, len;
  xstr xs;
  (void)sl;
  /* ѴΤҤ餬ʸ */
  xs.len = sc->char_count;
  xs.str = sc->ce[0].c;

  /* xsʬʸФ */
  for (start = 0; start < xs.len; start ++) {
    for (len = 1; len <= xs.len - start && len < MAX_OCHAIRE_LEN; len ++) {
      xstr part;
      part.str = &xs.str[start];
      part.len = len;
      if (anthy_select_row(&part, 0) == 0) {
	anthy_release_row();
      }
    }
  }
}

/* ؽԤ */
static void
learn_ochaire(struct splitter_context *sc,
	      struct segment_list *sl)
{
  int i;
  int count;

  if (anthy_select_section("OCHAIRE", 1)) {
    return ;
  }

  /* ؽΥͥƥ֤ʥȥä */
  release_negative_ochaire(sc, sl);

  /* ؽ򤹤 */
  for (count = 2; count <= sl->nr_segments && count < 5; count++) {
    /* 2ʸʾĹʸФ */

    for (i = 0; i <= sl->nr_segments - count; i++) {
      struct seg_ent *head = anthy_get_nth_segment(sl, i);
      struct seg_ent *s;
      xstr xs;
      int j;
      xs = head->str;
      if (xs.len < 2 && count < 3) {
	/* ڤʸؽ뤳Ȥ򤱤롢
	 * øheuristics */
	continue;
      }
      /* ʸʸ */
      for (j = 1, s = head->next; j < count; j++, s = s->next) {
	xs.len += s->str.len;
      }
      /**/
      commit_ochaire(head, count, &xs);
    }
  }
  if (anthy_select_section("OCHAIRE", 1)) {
    return ;
  }
  anthy_truncate_section(MAX_OCHAIRE_ENTRY_COUNT);
}
#else
/** recordˤؽη̤񤭹
 *@param[in]	head			ؽƬʸ
 *@param	count			ʸ
 *@param[in]	xs			ɤߤʸ
 *@param	without_indep		ؽƤϼΩ̵(1)ͭ(0)
 *@param	head_depword_len	°Ĺtrue == without_indep ΤߡΩǤϤʤ
 *@param	indep_count		ΩʬΥȤԤ(1)Ԥʤ(0)
 *@param	without_dep		ؽƤ°̵(1)ͭ(0)
 *@param	tail_depword_len	°Ĺtrue == without_dep Τߡ
 *
 * Patched by G-HAL
 *	Sat,23 Aug,2008
 *	Sat,29 Nov,2008
 *	Sat,17 Jan,2009
 *	Sat,24 Jan,2009
 *	Sun,08 Feb,2009
 */
static void commit_ochaire( const struct seg_ent* const head, int count, const xstr* const xs, int without_indep, int head_depword_len, int indep_count, int without_dep, int tail_depword_len )
{
  {
    if (head_depword_len < 1) {
      without_indep = 0;
    }
    if (tail_depword_len < 0) {
      without_dep = 0;
    }
  }
  { /* ߤ */
    xstr key = *xs;
    if (without_indep) {
      const int head_indepword_yomi_len = (head->len - head_depword_len);
      key.str += head_indepword_yomi_len;
      key.len -= head_indepword_yomi_len;
    }
    if (without_dep) {
      key.len -= tail_depword_len;
    }
    if (anthy_select_row_with_learn(&key,1,0)) {
      return;
    }
  }
  {
    const struct seg_ent* seg = head;
    const int old_nr    = anthy_get_nr_values();
    int old_freq_withindep    = 0;
    int old_freq_withoutindep = 0;
    int old_freq_withoutdep   = 0;
    int old_freq_withdep      = 0;
    int i;

    /* ׾μ */
    if (3 <= old_nr) {
      const int old_count = anthy_get_nth_value(0);
      i = 1 + old_count * 2;
      if ((i + 4) == old_nr) {
	old_freq_withindep    = anthy_get_nth_value( i + 0 );
	old_freq_withoutindep = anthy_get_nth_value( i + 1 );
	old_freq_withoutdep   = anthy_get_nth_value( i + 2 );
	old_freq_withdep      = anthy_get_nth_value( i + 3 );
	if (old_freq_withindep < 0) {
	  old_freq_withindep = 0;
	}
	if (old_freq_withoutindep < 0) {
	  old_freq_withoutindep = 0;
	}
	if (old_freq_withoutdep < 0) {
	  old_freq_withoutdep = 0;
	}
	if (old_freq_withdep < 0) {
	  old_freq_withdep = 0;
	}
      }
    }

    /* ؽϿ */
    anthy_set_nth_value( 0, count );
    seg = head;
    i = 0;
    if (without_indep) {
      xstr xs = seg->cands[seg->committed]->str;
      const int head_indepword_len = (xs.len - head_depword_len);
      xs.str += head_indepword_len;
      xs.len -= head_indepword_len;
      anthy_set_nth_value( i * 2 + 1, head_depword_len );
      anthy_set_nth_xstr( i * 2 + 2, &xs );
      ++i;
      seg = seg->next;
      if (indep_count) {
	++ old_freq_withoutindep;
      }
    } else {
      if (indep_count) {
	++ old_freq_withindep;
      }
    }
    for (; i < (count - 1); ++i, seg = seg->next) {
      anthy_set_nth_value( i * 2 + 1, seg->len );
      anthy_set_nth_xstr( i * 2 + 2, &seg->cands[seg->committed]->str );
    }
    {
      int yomi_len = seg->len;
      xstr tail;
      tail.str = seg->cands[seg->committed]->str.str;
      tail.len = seg->cands[seg->committed]->str.len;
      if (without_dep) {
	yomi_len -= tail_depword_len;
	tail.len -= tail_depword_len;
	++ old_freq_withoutdep;
      } else {
	++ old_freq_withdep;
      }
      anthy_set_nth_value( i * 2 + 1, yomi_len );
      anthy_set_nth_xstr( i * 2 + 2, &tail );
    }

    /* ׾ι */
    i = 1 + count * 2;
    anthy_set_nth_value( i + 0, old_freq_withindep );
    anthy_set_nth_value( i + 1, old_freq_withoutindep );
    anthy_set_nth_value( i + 2, old_freq_withoutdep );
    anthy_set_nth_value( i + 3, old_freq_withdep );

    anthy_truncate_row( i + 4 );
    anthy_mark_row_used();
  }
  return;
}

/** ʸڤؽΥͥƥ֤ʥȥä
 *@param[in]	head		ʸ
 *
 * Patched by G-HAL
 *	Sat,17 Jan,2009
 */
static void release_negative_entry( const xstr* const head )
{
  size_t	i, j;
  xstr		xs;
  const xstr*	key;

  for (i = 0; i <= head->len; ++i) {
    for (j = (head->len - i); 1 <= j; --j) {
      /* ؽǡ */
      xs.len = j;
      xs.str = &(head->str[i]);
      if (1 < j) {
	if (0 != anthy_select_longest_row(&xs)) {
	  j = 2;
	  continue;
	  /* ա anthy_select_longest_row() ϡʸʾΤ߸ */
	}
      } else {
	if (0 != anthy_select_row(&xs,0)) {
	  break;
	}
      }
      key = anthy_get_index_xstr();

      /* ȿؽ */
      anthy_pseudorelease_row();

      j = key->len;
    }
  }
  return;
}

/** ʸڤؽΥͥƥ֤ʥȥä
 *@param[in]	sc		ʸ
 *
 * Patched by G-HAL
 *	Tue,30 Dec,2008
 *	Sat,17 Jan,2009
 */
static void unlearn_negative_entry( const struct splitter_context* const sc )
{
  size_t	i, j;
  xstr		xs;
  const xstr*	key;

  for (i = 0; i < sc->char_count; ++i) {
    for (j = (sc->char_count - i); 1 <= j; --j) {
      /* ؽǡ */
      xs.len = j;
      xs.str = sc->ce[i].c;
      if (1 < j) {
	if (0 != anthy_select_longest_row(&xs)) {
	  j = 2;
	  continue;
	  /* ա anthy_select_longest_row() ϡʸʾΤ߸ */
	}
      } else {
	if (0 != anthy_select_row(&xs,0)) {
	  break;
	}
      }
      key = anthy_get_index_xstr();

      /* ȿؽ */
      anthy_unlearn_row();

      j = key->len;
    }
  }
  return;
}

/** ؽԤ
 *@param[in]	s		ʸ
 *
 * Patched by G-HAL
 *	Thu,21 Aug,2008, Sat,23 Aug,2008
 *	Fri,17 Oct,2008
 *	Sat,01 Nov,2008
 *	Fri,14 Nov,2008
 *	Wed,10 Dec,2008
 *	Tue,30 Dec,2008
 *	Sat,24 Jan,2009, Sun,25 Jan,2009
 *	Wed,04 Feb,2009
 *	Sun,08 Feb,2009
 */
int get_depword_len( const struct seg_ent* const s )
{
  const struct cand_ent* const ce = s->cands[s->committed];
  int ret = 0;

  if ((ce->core_elm_index < 0) || (ce->nr_words < NR_PARTS)) {
    /* ʼΩ̵ */
    if ((CEF_COMPOUND | CEF_COMPOUND_PART) & ce->flag) {
      if (ce->mw) {
	ret = ce->mw->cand_hint_length_of_dep;
      } else {
	ret = 0;	/* May be bug. */
      }
    } else if (CEF_GUESS_KATAcoreHIRAdep & ce->flag) {
      ret = 1;
    } else {
      ret = 0;
    }
  } else {
    const struct cand_elm* const depelm = &(ce->elm[ce->nr_words - NR_PARTS + PART_DEPWORD]);
    if (POS_NONE != anthy_wtype_get_pos(depelm->wt)) {
      ret = depelm->str.len;
    } else {
      ret = 0;
    }
  }
  return ret;
}

/** ؽԤ
 *@param[in]	sc		ʸ
 *@param[in]	sl		ʸᷲ
 *
 * Patched by G-HAL
 *	Thu,21 Aug,2008, Sat,23 Aug,2008
 *	Fri,17 Oct,2008
 *	Sat,01 Nov,2008
 *	Fri,14 Nov,2008
 *	Wed,10 Dec,2008
 *	Tue,30 Dec,2008
 *	Sat,24 Jan,2009, Sun,25 Jan,2009
 *	Wed,04 Feb,2009
 *	Sun,08 Feb,2009
 */
static void learn_ochaire( const struct splitter_context* const sc, const struct segment_list* const sl )
{
  const int enable_wo_indep
      = anthy_settings.anthy_mode.learn.enable_ochaire2_wo_indep
      || anthy_settings.anthy_mode.learn.enable_ochaire3_wo_indep
      || anthy_settings.anthy_mode.learn.enable_ochaire2_wo_indep_wo_dep
      || anthy_settings.anthy_mode.learn.enable_ochaire3_wo_indep_wo_dep;
  const int enable_wo_dep
      = anthy_settings.anthy_mode.learn.enable_ochaire2_wo_dep
      || anthy_settings.anthy_mode.learn.enable_ochaire3_wo_dep
      || anthy_settings.anthy_mode.learn.enable_ochaire2_wo_indep_wo_dep
      || anthy_settings.anthy_mode.learn.enable_ochaire3_wo_indep_wo_dep;
  int count;

  /* ʸڤؽ̷⤹륨ȥä */
  if (anthy_settings.anthy_mode.learn.enable_unlearn) {
    if (!anthy_select_section(CAND_HISTORY, 0)) {
      unlearn_negative_entry( sc );
    }
    if (!anthy_select_section(OCHAIRE, 0)) {
      unlearn_negative_entry( sc );
    }
  }

  if (anthy_select_section(OCHAIRE, 1)) {
    return;
  }

  /* OCHAIREؽΥͥƥ֤ʥȥä */
  if (anthy_settings.anthy_mode.learn.enable_release) {
    int i;
    for (i = 0; i < sl->nr_segments; ++i) {
      struct seg_ent* const head = anthy_get_nth_segment( sl, i );
      release_negative_entry( &(head->str) );
    }
  }

  /* ؽ򤹤 */
  for (count = anthy_settings.limit.ochaire_mindepth; count <= sl->nr_segments && count <= anthy_settings.limit.ochaire_maxdepth; ++count) {
    /* 2ʸʾĹʸФ */
    int i;

    for (i = 0; i <= sl->nr_segments - count; ++i) {
      /* ʸʸ */
      struct seg_ent* const head = anthy_get_nth_segment( sl, i );
      struct seg_ent* s;
      int j;
      int dont_learn = 1;

      /* ؽ̵ͭȽ */
      for (j = 0, s = head; j < count; ++j, s = s->next) {
	if (CEF_DONTLEARN_OCHAIRE_IFHAVEIT & s->cands[s->committed]->flag) {
	  dont_learn = 1;
	  break;
	}
	if ((anthy_settings.anthy_mode.extra_flag.exception_word.ochaire)
	    && (anthy_ishit_exception_word(&s->cands[s->committed]->str))
	) {
	  dont_learn = 1;
	  break;
	}
	if (!(CEF_DONTLEARN_OCHAIRE_IFONLYITS & s->cands[s->committed]->flag)) {
	  dont_learn = 0;
	}
      }

      if (!dont_learn) {
	xstr xs = head->str;
	int no_indepword = 0;
	int head_depword_len = 0;
	int tail_depword_len = 0;

	for (j = 1, s = head->next; j < count; j++, s = s->next) {
	  xs.len += s->str.len;
	}
	s = s->prev;
	if (enable_wo_indep) {
	  head_depword_len = get_depword_len( head );
	  if (head->len <= head_depword_len) {
	    no_indepword = 1;
	  }
	}
	if (enable_wo_dep) {
	  tail_depword_len = get_depword_len( s );
	}

	/* ʸؽ */
	{
	  int dup = 0;
	  if (((2 == count) && anthy_settings.anthy_mode.learn.enable_ochaire2)
	      || ((2 < count) && anthy_settings.anthy_mode.learn.enable_ochaire3)
	  ) {	/* ݤȳؽ */
	    if (!no_indepword) {
	      commit_ochaire( head, count, &xs, 0, 0, 1, 0, 0 );
	    } else {
	      commit_ochaire( head, count, &xs, 1, head_depword_len, 1, 0, 0 );
	    }
	    dup = (0 == tail_depword_len);
	  }
	  if (((2 == count) && anthy_settings.anthy_mode.learn.enable_ochaire2_wo_dep)
	      || ((2 < count) && anthy_settings.anthy_mode.learn.enable_ochaire3_wo_dep)
	  ) {	/* Ǹ°Ƴؽ */
	    if (!no_indepword) {
	      commit_ochaire( head, count, &xs, 0, 0, !dup, 1, tail_depword_len );
	    } else {
	      commit_ochaire( head, count, &xs, 1, head_depword_len, !dup, 1, tail_depword_len );
	    }
	  }
	}
	if (!no_indepword && (1 <= head_depword_len)) {
	  int dup = 0;
	  if (((2 == count) && anthy_settings.anthy_mode.learn.enable_ochaire2_wo_indep)
	      || ((2 < count) && anthy_settings.anthy_mode.learn.enable_ochaire3_wo_indep)
	  ) {	/* ƬμΩƳؽ */
	    commit_ochaire( head, count, &xs, 1, head_depword_len, 1, 0, 0 );
	    dup = (0 == tail_depword_len);
	  }
	  if (((2 == count) && anthy_settings.anthy_mode.learn.enable_ochaire2_wo_indep_wo_dep)
	      || ((2 < count) && anthy_settings.anthy_mode.learn.enable_ochaire3_wo_indep_wo_dep)
	  ) {	/* ƬμΩ졦Ǹ°Ƴؽ */
	    commit_ochaire( head, count, &xs, 1, head_depword_len, !dup, 1, tail_depword_len );
	  }
	}
      }
    }
  }
  return;
}
#endif

#if 0		/* Patched by G-HAL, Thu,30 Oct,2008 */
static int
learn_prediction_str(xstr *idx, xstr *xs)
{
  int nr_predictions;
  int i;
  anthy_time_t t = anthy_settings.timestamp.currentsession; /* time(NULL);*/	/* Patched by G-HAL, Wed,15 Oct,2008, Wed,22 Oct,2008 */
  if (anthy_select_row_with_learn(idx,1,0)) {	/* Patched by G-HAL, Sat,23 Aug,2008 */
    return 0;
  }
  nr_predictions = anthy_get_nr_values();

  /* ˤϥॹפ */
  for (i = 0; i < nr_predictions; i += 2) {
    xstr *log = anthy_get_nth_xstr(i + 1);
    if (!log) {
      continue;
    }
    if (anthy_xstrcmp(log, xs) == 0) {
      anthy_set_nth_int64( i, t );		/* Patched by G-HAL, Wed,22 Oct,2008 */
      break;
    }
  }

  /* ʤɲ */
  if (i == nr_predictions) {
    anthy_set_nth_int64( nr_predictions, t );	/* Patched by G-HAL, Wed,22 Oct,2008 */
    anthy_set_nth_xstr(nr_predictions + 1, xs);
    anthy_mark_row_used();
    return 1;
  }
  anthy_mark_row_used();
  return 0;
}
#endif

static void
learn_prediction(struct segment_list *sl)
{
  int i;
  int added = 0;
 #if 0		/* Patched by G-HAL, Fri,17 Oct,2008, Thu,30 Oct,2008, Tue,03 Feb,2009 */
  if (anthy_select_section("PREDICTION", 1)) {
    return ;
  }
 #else
  if (!anthy_settings.anthy_mode.learn.enable_prediction) {
    return;
  }
  if (anthy_select_section(CAND_HISTORY, 1)) {
    return;
  }
 #endif
  for (i = 0; i < sl->nr_segments; i++) {
    struct seg_ent *seg = anthy_get_nth_segment(sl, i);
    xstr *xs = &seg->cands[seg->committed]->str;

    if (seg->committed < 0) {
      continue;
    }
   #if 0		/* Patched by G-HAL, Thu,30 Oct,2008, Sat,01 Nov,2008 */
    if (learn_prediction_str(&seg->str, xs)) {
      added = 1;
    }
   #else
    if (0 == (CEF_DONTLEARN_PREDICTION & seg->cands[seg->committed]->flag)) {
      if (!anthy_settings.anthy_mode.extra_flag.exception_word.prediction
	  || !anthy_ishit_exception_word(xs))
      {
	if (anthy_learn_history_str(&seg->str, xs, 0)) {
	  added = 1;
	}
      }
    }
   #endif
  }
 #if 0	/* Patched by G-HAL, Sat,23 Aug,2008 */
  if (added) {
    anthy_truncate_section(MAX_PREDICTION_ENTRY);
  }
 #endif
}

static void
learn_unknown(struct segment_list *sl)
{
  int i;
  for (i = 0; i < sl->nr_segments; i++) {
    struct seg_ent *seg = anthy_get_nth_segment(sl, i);
    struct cand_ent *ce = seg->cands[seg->committed];
    if (ce->nr_words == 0) {
      anthy_add_unknown_word(&seg->str, &ce->str);
    }
  }
}

void
anthy_do_commit_prediction(xstr *src, xstr *xs)
{
 #if 0		/* Patched by G-HAL, Fri,17 Oct,2008, Thu,30 Oct,2008, Sat,01 Nov,2008, Tue,03 Feb,2009 */
  if (anthy_select_section("PREDICTION", 1)) {
    return ;
  }
  learn_prediction_str(src, xs);
 #else
  if (!anthy_settings.anthy_mode.learn.enable_prediction) {
    return;
  }
  if (!anthy_settings.anthy_mode.extra_flag.exception_word.prediction
      || !anthy_ishit_exception_word(xs))
  {
    if (0 == anthy_select_section(CAND_HISTORY, 1)) {
      anthy_learn_history_str( src, xs, 0 );
    }
  }
  return;
 #endif
}

void
anthy_proc_commit(struct segment_list *sl,
		  struct splitter_context *sc)
{
  /* ƼγؽԤ */
  learn_swapped_candidates(sl);
  learn_resized_segment(sc, sl);
  clear_resized_segment(sc, sl);
  learn_ochaire(sc, sl);
  learn_prediction(sl);
  learn_unknown(sl);
  anthy_learn_cand_history(sl);
}
/* vim:ts=8 sw=2 nomodified:
 */
